package xyz.veronie.bgg.types;

public enum FamilyType {
	ALL("any", ""),
	BG_FAMILY("board game family", "boardgamefamily"),
	RPG("RPG", "rpg"),
	RPG_PERIODIC("RPG periodical", "rpgperiodical");
	
	private String name; //< the display name
	private String familyApiString; //< the THINGTYPE string for BGG XMLAPI2
	
	private FamilyType(String name, String familyApiString) {
		this.name = name;
		this.familyApiString = familyApiString;
	}
	
	@Override
	public String toString() {
		return this.name;
	}

	/// return the string used in BGG XMLAPI2 to identify the thingtype
	public String toApiString() {
		return this.familyApiString;
	}
}
